Halp = CreateFrame("frame")

local inBG
local count = 0 -- number of times Halp! key has been pressed
local timer = 0 -- time since last Halp! key press
local delay = 1 -- time (in seconds) after which to send the Halp! message

Halp:RegisterEvent("PLAYER_ENTERING_WORLD")

local function eventHandler(self, event, ...)
	Halp:WhereAmI()
end

-- if more than ..delay.. seconds have passed since last Halp! key press, send Halp! message
local function onUpdate(frame, elapsed)
	timer = timer + elapsed
	if (timer >= delay) then
		Halp:SendHelpRequest()
		timer = 0
	end
end

-- checks that the player is in a zone where Halp! is active
function Halp:WhereAmI()
	local _, instanceType = IsInInstance()
	if (instanceType == "pvp") then
		inBG = true
	else
		Halp:SetScript("OnUpdate", nil)
	end
	
end

-- registers the Halp request, resets the timer
function Halp:HelpRequest()
	if inBG then
		if (count == 0) then
			Halp:SetScript("OnUpdate", onUpdate)
		end
		count = count + 1
		timer = 0
	end
end

-- sends the Halp! request
function Halp:SendHelpRequest()
	local subzone = GetSubZoneText();
	if (subzone and subzone ~= "" and inBG) then
		--DEFAULT_CHAT_FRAME:AddMessage(count .. " incoming to " .. subzone .. "!");
		SendChatMessage(count .. " incoming to " .. subzone .. "!","BATTLEGROUND");
	end
	count = 0
	Halp:SetScript("OnUpdate", nil)
end

-- sends a "zone safe" message if in a bg, cancels all pending Halp! requests
function Halp:ZoneSafe()
	if (subzone and subzone ~= "" and inBG) then
		SendChatMessage(subzone .. " is safe.","BATTLEGROUND");
	end
	count = 0
	Halp:SetScript("OnUpdate", nil)
end

Halp:SetScript("OnEvent", eventHandler)

-- keybinds
BINDING_HEADER_HALPHEADER = "Halp!";
BINDING_NAME_HALP1 = "Ask for Halp!";
BINDING_NAME_HALP2 = "Area clear.";